#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "recherche_pairs.h"
#include "recherche_premiers.h"

int main(int argc, char *argv[]){
	FILE* fichier = NULL;
	int list = 0, i = 0;
	
	//Ouverture du fichier si l'option list est precisee dans les arguments.
	for(i = 1 ; i < argc ; i++){
		if(strcmp(argv[i], "list") == 0){
			list = 1;
			break;
		}
	}
	
	if(list){
		fichier = fopen("nb.txt", "r+");
		if(fichier == NULL){
			printf("Erreur d'ouverture du fichier. Raison possible : fichier inexistant. Essai de creation du fichier.\n");
			fichier = fopen("nb.txt", "w");
			fclose(fichier);
			fichier = fopen("nb.txt", "r+");
			if(fichier == NULL){
				printf("Ouverture du fichier impossible. Fin.");
				exit(EXIT_FAILURE);
			}
		}
	}
	
	
	/* Intepretation des arguments.
	Appel des fonctions correspondantes aux arguments donnés.*/
	if(argc <= 1)
		recherche_pairs1("3");
	else if(argc == 2){
		if(strcmp(argv[1], "2") == 0)
			recherche_pairs2("3");
		else if(strcmp(argv[1], "2o") == 0)
			recherche_pairs2_ordre("3");
		else if(strcmp(argv[1], "table") == 0)
			recherche_premiers1();
		else if(strcmp(argv[1], "list") == 0)
			recherche_pairs_fichier1(fichier, "3");
		else if(strcmp(argv[1], "help") == 0)
			printf(" table : employer un tableau de nombres pour faire la recherche. Si cette option est choisie (qui decuple la vitesse), vous ne pouvez pas choisir le nombre de depart. Il est conseille d'avoir un grand espace swap si vous choisissez cette option.\n list : utiliser un fichier dans lequel ecrire la liste. Si vous employez cette option avec l'option table, ce fichier sera utilise pour remplir la table avant de commencer les operations.\n 2 : permet d'utiliser deux coeurs, multipliant par presque 2 la vitesse (et environ par 1.5 avec l'option table). Veuillez toujours placer cette option en dernier.\n Le nombre de depart. Ne peut etre precise que sans l'option table. Placez-le apres l'option list et avant l'option 2 (si precisees).\n");
		else{
			if(strtol(argv[1], NULL, 10) > 2)
				recherche_pairs1(argv[1]);
			else{
				printf("L'argument entre n'est pas correct. Entrez table ; list ; 2 (2 coeurs) ou le nombre de depart (superieur a 2). Fin.");
				exit(EXIT_FAILURE);
			}
		}
	}
	else if(argc == 3){
		if(strcmp(argv[1], "table") == 0){
			if(strcmp(argv[2], "2") == 0)
				recherche_premiers2();
			else if(strcmp(argv[2], "list") == 0)
				recherche_premiers_fichier1(fichier);
			else{
				printf("Le deuxieme argument entre n'est pas correct. Entrez table ; list ; 2 (2 coeurs) ou le nombre de depart (superieur a 2). Fin.");
				exit(EXIT_FAILURE);
			}
		}
		else if(strcmp(argv[1], "list") == 0){
			if(strcmp(argv[2], "2") == 0)
				recherche_pairs_fichier2(fichier, "3");
			else if(strcmp(argv[2], "table") == 0)
				recherche_premiers1();
			else{
				if(strtol(argv[2], NULL, 10) > 2)
					recherche_premiers_fichier1(fichier);
				else{
					printf("Le deuxieme argument entre n'est pas correct. Entrez table ; list ; 2 (2 coeurs) ou le nombre de depart (superieur a 2). Fin.");
					exit(EXIT_FAILURE);
				}
			}
		}
		else if(strtol(argv[1], NULL, 10) > 2){
			if(strcmp(argv[2], "2") == 0)
				recherche_pairs2(argv[2]);
			else if(strcmp(argv[2], "2o") == 0)
				recherche_pairs2_ordre(argv[2]);
			else{
				printf("Le deuxieme argument entre n'est pas correct. Entrez 2 (2 coeurs) ou rien (1 coeur). Les autres arguments doivent etre places devant. Fin.");
				exit(EXIT_FAILURE);
			}
		}
	}
	else if(argc == 4){
		if(strcmp(argv[1], "table") == 0){
			if(strcmp(argv[2], "list") == 0){
				if(strcmp(argv[3], "2") == 0)
					recherche_premiers_fichier2(fichier);
				else{
					printf("Le troisieme argument entre n'est pas correct. Entrez 2 (2 coeurs) ou rien (1 coeur). Fin.");
					exit(EXIT_FAILURE);
				}
			}
		}
		else if(strcmp(argv[1], "list") == 0){
			if(strcmp(argv[2], "table") == 0){
				if(strcmp(argv[3], "2") == 0)
					recherche_premiers_fichier2(fichier);
				else{
					printf("Le troisieme argument entre n'est pas correct. Entrez 2 (2 coeurs) ou rien (1 coeur). Fin.");
					exit(EXIT_FAILURE);
				}
			}
			else if(strtol(argv[2], NULL, 10) > 2){
				if(strcmp(argv[3], "2") == 0)
					recherche_premiers_fichier2(fichier);
				else{
					printf("Le troisieme argument entre n'est pas correct. Entrez 2 (2 coeurs) ou rien (1 coeur). Fin.");
					exit(EXIT_FAILURE);
				}
			}
		}
	}
	else{
		printf("L'un des arguments entres est faux. Verifiez vos arguments. Rappel :\n table : employer un tableau de nombres pour faire la recherche. Si cette option est choisie (qui decuple la vitesse), vous ne pouvez pas choisir le nombre de depart. Il est conseille d'avoir un grand espace swap si vous choisissez cette option.\n list : utiliser un fichier dans lequel ecrire la liste. Si vous mettez cette option avec l'option table, ce fichier sera utilise pour remplir la table avant de commencer les operations.\n 2 : permet d'utiliser deux coeurs, multipliant par presque 2 la vitesse. Veuillez toujours placer cette option en dernier.\n Le nombre de depart. Ne peut etre preciser que sans l'option table. Placez-le apres l'option list et avant l'option 2 (si precisees).\n\nFin.");
		exit(EXIT_FAILURE);
	}
	
	fclose(fichier);
	exit(EXIT_SUCCESS);
}
