#include <gmp.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include "recherche_pairs.h"

static mpz_t nb;
static mpz_t nb_thread;

void recherche_pairs_ordre_fichier2(FILE* fichier, char nb_depart[]){
}

void recherche_pairs_fichier2(FILE* fichier, char nb_depart[]){
}

void *recherche_pairs_ordre_thread(void *arg){
	mpz_add_ui(nb_thread, nb, 2);
	mpz_t nb_test;
	mpz_init_set_str (nb_test, "2", 10);
	int verif = 1;
	mpz_t mod;
	mpz_init (mod);
	mpz_t div;
	mpz_init_set_str (div, "0", 10);
	
	//on commence à calculer.
	printf("Debut du calcul. Les nombres trouves ici seront conserves (fichier nb.txt, meme repertoire que le programme). Ctrl + C pour arreter.");
	while(1){
		mpz_cdiv_q_ui (div, nb_thread, 2);
		verif = 1;
		mpz_set_str (nb_test, "2", 10);
		while(mpz_cmp (nb_test, div) < 0){
			mpz_mod (mod, nb_thread, nb_test);
			if(mpz_cmp_ui (mod, 0) == 0){
				verif = 0;
				break;
			}
			mpz_add_ui (nb_test, nb_test, 1);
		}
		if(verif){
			while(nb_thread > nb);
			gmp_printf("%Zd\n", nb);
		}
		mpz_add_ui (nb, nb, 4);
	}

	mpz_clear (nb_thread);
	mpz_clear (nb_test);
	mpz_clear (mod);
	mpz_clear (div);
	
	(void) arg;
	pthread_exit(NULL);
}

void recherche_pairs2_ordre(char nb_depart[]){
	mpz_t nb_test;
	mpz_init_set_str (nb, nb_depart, 10);
	mpz_init_set_str (nb_test, "2", 10);
	int verif = 1;
	mpz_t mod;
	mpz_init (mod);
	mpz_t div;
	mpz_init_set_str (div, "0", 10);
	
	//si nb est pair, on lui ajoute 1.
	mpz_mod_ui(mod, nb, 2);
	if(mpz_cmp_ui(mod, 0) == 0)
		mpz_add_ui(nb, nb, 1);
	
	
	pthread_t thread;
	if(pthread_create(&thread, NULL, recherche_pairs_ordre_thread, NULL) == -1) {
    		perror("pthread_create");
    		exit(EXIT_FAILURE);
    	}
	
	//on commence à calculer.
	printf("Debut du calcul. Les nombres trouves ici seront conserves (fichier nb.txt, meme repertoire que le programme). Ctrl + C pour arreter.");
	while(1){
		mpz_cdiv_q_ui (div, nb, 2);
		verif = 1;
		mpz_set_str (nb_test, "2", 10);
		while(mpz_cmp (nb_test, div) < 0){
			mpz_mod (mod, nb, nb_test);
			if(mpz_cmp_ui (mod, 0) == 0){
				verif = 0;
				break;
			}
			mpz_add_ui (nb_test, nb_test, 1);
		}
		if(verif){
			while(nb > nb_thread);
			gmp_printf("%Zd\n", nb);
		}
		mpz_add_ui (nb, nb, 4);
	}

	mpz_clear (nb);
	mpz_clear (nb_test);
	mpz_clear (mod);
	mpz_clear (div);
}

void *recherche_pairs_thread(void *arg){
	mpz_add_ui(nb_thread, nb, 2);
	mpz_t nb_test;
	mpz_init_set_str (nb_test, "2", 10);
	int verif = 1;
	mpz_t mod;
	mpz_init (mod);
	mpz_t div;
	mpz_init_set_str (div, "0", 10);
	
	//on commence à calculer.
	printf("Debut du calcul. Les nombres trouves ici seront conserves (fichier nb.txt, meme repertoire que le programme). Ctrl + C pour arreter.");
	while(1){
		mpz_cdiv_q_ui (div, nb_thread, 2);
		verif = 1;
		mpz_set_str (nb_test, "2", 10);
		while(mpz_cmp (nb_test, div) < 0){
			mpz_mod (mod, nb_thread, nb_test);
			if(mpz_cmp_ui (mod, 0) == 0){
				verif = 0;
				break;
			}
			mpz_add_ui (nb_test, nb_test, 1);
		}
		if(verif){
			gmp_printf("%Zd\n", nb);
		}
		mpz_add_ui (nb, nb, 4);
	}

	mpz_clear (nb_thread);
	mpz_clear (nb_test);
	mpz_clear (mod);
	mpz_clear (div);
	
	(void) arg;
	pthread_exit(NULL);
}

void recherche_pairs2(char nb_depart[]){
	mpz_t nb_test;
	mpz_init_set_str (nb, nb_depart, 10);
	mpz_init_set_str (nb_test, "2", 10);
	int verif = 1;
	mpz_t mod;
	mpz_init (mod);
	mpz_t div;
	mpz_init_set_str (div, "0", 10);
	
	//si nb est pair, on lui ajoute 1.
	mpz_mod_ui(mod, nb, 2);
	if(mpz_cmp_ui(mod, 0) == 0)
		mpz_add_ui(nb, nb, 1);
	
	
	pthread_t thread;
	if(pthread_create(&thread, NULL, recherche_pairs_thread, NULL) == -1) {
    		perror("pthread_create");
    		exit(EXIT_FAILURE);
    	}
	
	//on commence à calculer.
	printf("Debut du calcul. Les nombres trouves ici seront conserves (fichier nb.txt, meme repertoire que le programme). Ctrl + C pour arreter.");
	while(1){
		mpz_cdiv_q_ui (div, nb, 2);
		verif = 1;
		mpz_set_str (nb_test, "2", 10);
		while(mpz_cmp (nb_test, div) < 0){
			mpz_mod (mod, nb, nb_test);
			if(mpz_cmp_ui (mod, 0) == 0){
				verif = 0;
				break;
			}
			mpz_add_ui (nb_test, nb_test, 1);
		}
		if(verif){
			gmp_printf("%Zd\n", nb);
		}
		mpz_add_ui (nb, nb, 4);
	}

	mpz_clear (nb);
	mpz_clear (nb_test);
	mpz_clear (mod);
	mpz_clear (div);
}

void recherche_pairs_fichier1(FILE* fichier, char nb_depart[]){
	mpz_t nb_test;
	mpz_init_set_str (nb, nb_depart, 10);
	mpz_init_set_str (nb_test, "2", 10);
	int verif = 1;
	mpz_t mod;
	mpz_init (mod);
	mpz_t div;
	mpz_init_set_str (div, "0", 10);
	
	//si nb est pair, on lui ajoute 1.
	mpz_mod_ui(mod, nb, 2);
	if(mpz_cmp_ui(mod, 0) == 0)
		mpz_add_ui(nb, nb, 1);
	
	
	fseek(fichier, 0, SEEK_END);//on va a la fin du fichier
	//on commence à calculer.
	printf("Debut du calcul. Les nombres trouves ici seront conserves (fichier nb.txt, meme repertoire que le programme). Ctrl + C pour arreter.");
	while(1){
		mpz_cdiv_q_ui (div, nb, 2);
		verif = 1;
		mpz_set_str (nb_test, "2", 10);
		while(mpz_cmp (nb_test, div) < 0){
			mpz_mod (mod, nb, nb_test);
			if(mpz_cmp_ui (mod, 0) == 0){
				verif = 0;
				break;
			}
			mpz_add_ui (nb_test, nb_test, 1);
		}
		if(verif){
			gmp_printf("%Zd\n", nb);
			gmp_fprintf(fichier, "%Zd ", nb);//on ecrit le nombre dans le fichier
			
		}
		mpz_add_ui (nb, nb, 2);
	}

	mpz_clear (nb);
	mpz_clear (nb_test);
	mpz_clear (mod);
	mpz_clear (div);
	mpz_clear (nb_thread);
}


void recherche_pairs1(char nb_depart[]){
	mpz_t nb_test;
	mpz_init_set_str (nb, nb_depart, 10);
	mpz_init_set_str (nb_test, "2", 10);
	int verif = 1;
	mpz_t mod;
	mpz_init (mod);
	mpz_t div;
	mpz_init_set_str (div, "0", 10);
	
	//si nb est premier, on lui ajoute 1.
	mpz_mod_ui(mod, nb, 2);
	if(mpz_cmp_ui(mod, 0) == 0)
		mpz_add_ui(nb, nb, 1);
	
	
	//on commence à calculer.
	printf("Debut du calcul (sans fichier). Les nombres trouves ici ne seront pas conserves. Ctrl + C pour arreter.");
	while(1){
		mpz_cdiv_q_ui (div, nb, 2);
		verif = 1;
		mpz_set_str (nb_test, "2", 10);
		while(mpz_cmp (nb_test, div) < 0 && verif){
			mpz_mod (mod, nb, nb_test);
			if(mpz_cmp_ui (mod, 0) == 0){
				verif = 0;
				break;
			}
			mpz_add_ui (nb_test, nb_test, 1);
		}
		if(verif)
			gmp_printf("%Zd\n", nb);
		mpz_add_ui (nb, nb, 2);
	}

	mpz_clear (nb);
	mpz_clear (nb_test);
	mpz_clear (mod);
	mpz_clear (div);
	mpz_clear (nb_thread);
}
