#include <gmp.h>
#include <stdio.h>
#include <stdlib.h>
#include "recherche_premiers.h"

void recherche_premiers_fichier2(FILE* fichier){
}

void recherche_premiers2(){
}

void recherche_premiers_fichier1(FILE* fichier){
	//Initialisation du tableau de nombres premiers
	mpz_t* nb;
	nb = malloc(sizeof(mpz_t));
	mpz_init_set_str(nb[0], "3", 10);
	
	//Initialisation du tableau par le fichier.
	fgetc(fichier);//On avance de deux caracteres ("3 ")
	fgetc(fichier);
	
	unsigned long long taille_tableau = 0;
	mpz_t nombre_en_cours;
	mpz_init(nombre_en_cours);
	while ((gmp_fscanf (fichier,"%Zd ", &nombre_en_cours)) != EOF){
		taille_tableau++;
		nb = realloc(nb, (taille_tableau+1)*sizeof(mpz_t));
		mpz_init_set(nb[taille_tableau], nombre_en_cours);
	}
	mpz_clear(nombre_en_cours);

	//Initialisation des autres variables
	mpz_t div;
	mpz_t mod;
	int verif = 1;
	unsigned long long i = 0;
	mpz_init_set_str (div, "0", 10);
	mpz_init(mod);

	//Debut du calcul. On travaille sur nb[taille_tableau].
	while(1){
		mpz_cdiv_q_ui (div, nb[taille_tableau], 2);
		verif = 1;
		i = 0;
		while(mpz_cmp (nb[i], div) < 0){
			mpz_mod (mod, nb[taille_tableau], nb[i]);
			if(mpz_cmp_si (mod, 0) == 0){
				verif = 0;
				break;
			}
			i = i + 1;
		}
		if(verif){
			gmp_printf("%Zd\n", nb[taille_tableau]);
			gmp_fprintf(fichier, "%Zd ", nb[taille_tableau]);//On ecrit le nombre dans le fichier
//		}
//		if(verif){//si on a trouve un nombre, on augmente la taille du tableau de nombres. On travaillera desormais sur la case suivante.
			taille_tableau++;
			nb = realloc(nb, (taille_tableau+1)*sizeof(mpz_t));
			mpz_init_set(nb[taille_tableau], nb[taille_tableau-1]);//Il faut que le nouveau nombre trouve reparte AU MEME ENDROIT que la ou s'est arrete l'ancien.
		}
		mpz_add_ui (nb[taille_tableau], nb[taille_tableau], 2);
	}
	for(i = 0 ; i <= taille_tableau ; i++){
		mpz_clear(nb[i]);
	}
	mpz_clear(div);
	mpz_clear(mod);
	free(nb);
}


void recherche_premiers1(){
	//Initialisation du tableau de nombres premiers
	mpz_t* nb;
	nb = malloc(sizeof(mpz_t));
	mpz_init_set_str(nb[0], "3", 10);

	//Initialisation des autres variables
	mpz_t div;
	mpz_t mod;
	int verif = 1;
	unsigned long long taille_tableau = 0, i = 0;
	mpz_init_set_str (div, "0", 10);
	mpz_init(mod);

	//Debut du calcul. On travaille sur nb[taille_tableau].
	while(1){
		mpz_cdiv_q_ui (div, nb[taille_tableau], 2);
		verif = 1;
		i = 0;
		while(mpz_cmp (nb[i], div) < 0){
			mpz_mod (mod, nb[taille_tableau], nb[i]);
			if(mpz_cmp_si (mod, 0) == 0){
				verif = 0;
				break;
			}
			i = i + 1;
		}
		if(verif){
			gmp_printf("%Zd\n", nb[taille_tableau]);
//		}
//		if(verif){//si on a trouve un nombre, on augmente la taille du tableau de nombres. On travaillera desormais sur la case suivante.
			taille_tableau++;
			nb = realloc(nb, (taille_tableau+1)*sizeof(mpz_t));
			mpz_init_set(nb[taille_tableau], nb[taille_tableau-1]);//Il faut que le nouveau nombre trouve reparte AU MEME ENDROIT que la ou s'est arrete l'ancien.
		}
		mpz_add_ui (nb[taille_tableau], nb[taille_tableau], 2);
	}
	for(i = 0 ; i <= taille_tableau ; i++){
		mpz_clear(nb[i]);
	}
	mpz_clear(div);
	mpz_clear(mod);
	free(nb);
}
